if {![file exist "tkblog.cfg" ]} {
    puts "ERROR! Couldn't find tkblog.cfg"
    exit
} else {
    source ./tkblog.cfg
}

namespace eval blsgv {
          variable start        [clock format [clock seconds] -format "%c"]
          variable bloghome     [pwd]
          variable version      "Blogsync v2.40"
          variable logname      "$bloghome/blog.log"
          variable newsession   1
          variable logid        "--"
          variable blogdata     "archive/blog.dat"
          variable blogtemplate   "blog.template"
          variable date_format    $date_format
          variable time_format    $time_format
          variable arcdir       $arcdir
          variable header       "$bloghome/header.template"
          variable footer       "$bloghome/footer.template"
}


proc logmsg {msg} {

      set  timestamp [clock format [clock seconds] -format "%d %b %H:%M:%S"]
      set  logfile [open $blsgv::logname a]

      if {$blsgv::newsession==1} {
         puts $logfile "\n  $timestamp  $blsgv::logid $msg"
         set blsgv::newsession 0
      }  else {
         puts $logfile "  $timestamp  $blsgv::logid $msg"
      }
      close $logfile
}

logmsg "$blsgv::version -- $blsgv::start"

if {![file exist $blsgv::blogdata]} {
   logmsg "ERROR! Couldn't find $blsgv::blotdata!"
   exit
}


proc getarchash {} {
     global archive

     set blogdat      [open $blsgv::blogdata]
     
     while {[gets $blogdat line]!=-1} {
           if {[regexp {<!-- blogid*} $line]} {
              set br 0
              set keep $line
              set bid [split $line]
              set bid [lindex $bid 2]

              while {[gets $blogdat line]!=-1} {
                    if {[regexp {<!--/blog-->} $line]} {
                       break
                    } else {
                       while {[gets $blogdat line]!=-1} {
                               if {[regexp {<!--blogtext-->} $line]} {
                                    while {[gets $blogdat line]!=-1} {
                                            if {![regexp {<!--/blogtext-->} $line]} {
                                                  set blog [append  blog "$line\n"]
                                            } else {
                                                  set archive($bid) $blog
                                                  set blog ""
                                                  set br 1
                                                  break
                                            }
                                    }
                               }
                               if {$br} {break}
                      }
                    }
                    if {$br} {break}
             }
           }
     }
     close $blogdat
}

proc applytplt {} {
     global archive totalblogs

     set blogtemp   [open tmp/blogtemp w]
     set sortedarc  [lsort -decreasing [array names archive]]
     set totalblogs [llength $sortedarc]

     for {set x 0}  {$x<$totalblogs} {incr x } {
          set blogid [lindex $sortedarc $x]
          set blgtplt    [open $blsgv::blogtemplate]
          while {[gets $blgtplt line]!=-1} {
                  if {![regexp {<!--blog-->} $line]} {
                      set br 0
                  } else {
                      set blsgv::blogd [clock format $blogid -format $blsgv::date_format]
                      set blsgv::blogt [clock format $blogid -format $blsgv::time_format]
                      puts  $blogtemp "<!-- blogid $blogid -->"
                      puts  $blogtemp "<a name=\"$blogid\"><\/a>"

                       while {[gets $blgtplt line]!=-1} {
                               if {![regexp {<!--/blog-->} $line]} {
                                    if {[regexp   {<\$blogdate>} $line] || \
                                        [regexp   {<\$blogtime>} $line]} {
                                        set  line [regsub {<\$blogdate>} $line $blsgv::blogd subline]
                                        set  line $subline
                                        set  line  [regsub {<\$blogtime>} $line $blsgv::blogt subline]
                                        puts $blogtemp $subline
                                    } elseif {[regexp {<\$blogentry>} $line]} {
                                         puts $blogtemp <!--blogtext-->
                                         set  line [regsub {<\$blogentry>} $line $archive($blogid) subline]
                                         puts  -nonewline $blogtemp $subline
                                         puts  $blogtemp <!--/blogtext-->
                                    } else {
                                         puts  $blogtemp $line
                                    }
                               } else {
                                    puts $blogtemp "$line\n"
                                    set br 1
                                    break
                               }
                               if {$br} {break}
                       }
                  }
                 if {$br} {break}
          }
          close $blgtplt
     }
     close $blogtemp
}

getarchash
applytplt
file delete "archive/blog.bak"
file rename $blsgv::blogdata  "archive/blog.bak"
file copy  "tmp/blogtemp" $blsgv::blogdata
set end [clock format [clock seconds] -format "%c"] 
logmsg "$totalblogs templates synced at -- $end"
